/******************************************************************************
 * {]p̡GFjt@²EF@2004/02
 *
 * nĥ GPL vAҦ{XҥiۥѴGέק
 * Ҧ{]p̤TФHOd :)
 ******************************************************************************/


#ifndef FRM_EDITTERM_CPP
#define FRM_EDITTERM_CPP

#include <wx/caret.h>
#include <wx/file.h>
#include <wx/filedlg.h>

//#include "scd_telnet_main.cpp"
//#include "scd_editterm.cpp"
#include "editterm_win.cpp"
// ============================================================================

class frame_EditTerm : public wxFrame
{
private:
	SCD_EditTerm *editterm;
	EditTerm_win *editterm_win;
	wxMenu *menuCharProp;	
	
	wxString filename;

public:
	frame_EditTerm(const wxString& title, const wxPoint& pos, const wxSize& size,
	long style = wxDEFAULT_FRAME_STYLE | wxNO_FULL_REPAINT_ON_RESIZE );


	~frame_EditTerm()
	{
//     	delete editterm;
//	 	delete editterm_win;
	}    



	bool SaveFile();
	bool SaveFile(wxString _filename, wxString content);
	bool SaveNewFile();

	void OnFile(wxCommandEvent& event);
	void OnEdit(wxCommandEvent& event);
	void OnCharProperty(wxCommandEvent& event);

	void UpdateTitle();
	void SetTerminalFont(wxFont fnt);
	
	void OnClose(wxCloseEvent& event);
	void OnAbout(wxCommandEvent& event);

	void OnActivate(wxActivateEvent& event)
	{	editterm_win->SetFocus();	}

private:
    DECLARE_EVENT_TABLE()
};    


enum
{
	MENU_FILE_BEGIN,

	MENU_OPENNEWWINDOW,
	MENU_OPENNEWFILE,
	MENU_OPENOLDFILE,
	MENU_SAVEFILE,
	MENU_SAVENEWFILE,
	MENU_QUIT,

	MENU_FILE_END,



    MENU_CHARPROP_BEGIN,

    MENU_CHARPROP_NORMAL,
    MENU_CHARPROP_BLINK,
    MENU_CHARPROP_UNBLINK,
    MENU_CHARPROP_HIGHLIGHT,
    MENU_CHARPROP_UNHIGHLIGHT,
    MENU_CHARPROP_UNDERLINE,
    MENU_CHARPROP_UNUNDERLINE,

	MENU_CHARPROP_CHCOLOR_1,	MENU_CHARPROP_CHCOLOR_2,	MENU_CHARPROP_CHCOLOR_3,
	MENU_CHARPROP_CHCOLOR_4,	MENU_CHARPROP_CHCOLOR_5,	MENU_CHARPROP_CHCOLOR_6,
 	MENU_CHARPROP_CHCOLOR_7,	MENU_CHARPROP_CHCOLOR_8,

	MENU_CHARPROP_BGCOLOR_1,	MENU_CHARPROP_BGCOLOR_2,	MENU_CHARPROP_BGCOLOR_3,
	MENU_CHARPROP_BGCOLOR_4,	MENU_CHARPROP_BGCOLOR_5,	MENU_CHARPROP_BGCOLOR_6,
 	MENU_CHARPROP_BGCOLOR_7,	MENU_CHARPROP_BGCOLOR_8,
 	
    MENU_CHARPROP_END,



	MENU_EDIT_BEGIN,

	MNU_DELETELINE,
	MNU_DELETELINETAIL,
	MNU_JOINLINE,
	MNU_COPY,
	MNU_COPY_ANSI,
	MNU_PASTE,
	MNU_PASTE_ANSI,
	MNU_SELECTALL,
	MNU_INPUT_LINE,

	MENU_EDIT_END,

	MENU_About
};

BEGIN_EVENT_TABLE(frame_EditTerm, wxFrame)
	EVT_MENU_RANGE(MENU_FILE_BEGIN, MENU_FILE_END, frame_EditTerm::OnFile)
	EVT_MENU_RANGE(MENU_EDIT_BEGIN, MENU_EDIT_END, frame_EditTerm::OnEdit)
	EVT_MENU_RANGE(MENU_CHARPROP_BEGIN, MENU_CHARPROP_END, frame_EditTerm::OnCharProperty)
	EVT_ACTIVATE(frame_EditTerm::OnActivate)
	EVT_MENU(MENU_About, frame_EditTerm::OnAbout)

	EVT_CLOSE(frame_EditTerm::OnClose)
END_EVENT_TABLE()


void frame_EditTerm::UpdateTitle()
{
	wxString t;
	t = _T("BBMan - ANSI mrs边 [ ");
 	if( filename == wxEmptyString )	t += _T("}sɮ");
  	else	t += filename;
  	if( editterm->isChanged() )	t += _T(" *");
   	t += _T(" ]");
	SetTitle( t );
}    

bool frame_EditTerm::SaveNewFile()
{
	wxString path = wxFileSelector( _T("tss") , _T(""), _T("}sɮ.ans"), _T("ans") , _T("BBS mrɮ (*.ans)|*.ans|Ҧɮ (*.*)|*.*") , wxSAVE | wxOVERWRITE_PROMPT , this );
	if( path.empty() )	return false;
	return SaveFile( path , editterm->GetAllContent(true) );
}    
bool frame_EditTerm::SaveFile()
{
    if( filename == wxEmptyString )	return SaveNewFile();
    else return SaveFile( filename , editterm->GetAllContent(true) );
}    
bool frame_EditTerm::SaveFile(wxString _filename, wxString content)
{
	FILE *fp = wxFopen( _filename , wxT( "wb" ) );
	fwrite( content.c_str() , 1, content.Len() , fp );
	fclose(fp);

    filename = _filename;
    editterm->setUnchanged();
    UpdateTitle();
    return true;
}    

void frame_EditTerm::OnFile(wxCommandEvent& event)
{
	int id = event.GetId();
	switch(id)
	{
		case MENU_OPENNEWWINDOW :
			ShowAnsiEditor();
  			break;
	    case MENU_OPENNEWFILE :
			if( editterm->isChanged() )
			{
				if( wxNO == wxMessageBox( _T("ثeewB|xsATwnثeeH") , _T("T{"), wxYES_NO ) )
					break;
			}

       		editterm->abs_CleanAll();
       		editterm->gotoXY(0,0);
       		editterm->ScrollToCaret();
			editterm->repaint();

       		filename = wxEmptyString;
       		editterm->setUnchanged();
       		UpdateTitle();
	        break;
	    case MENU_OPENOLDFILE :
	        {
				if( editterm->isChanged() )
				{
					if( wxNO == wxMessageBox( _T("ثeewB|xsATwnثeeH") , _T("T{"), wxYES_NO ) )
						break;
				}
    
				wxString path = wxFileSelector( _T("}") , _T(""), _T(""), _T("ans") , _T("BBS mrɮ (*.ans)|*.ans|Ҧɮ (*.*)|*.*") , wxOPEN | wxFILE_MUST_EXIST , this );
				if( path.empty() )	return;
				
				FILE *fp = wxFopen( path , wxT( "rb" ) );
				if(fp == NULL)	return;
				wxString content;
				wxChar buf[2000];
				while( !feof(fp) )
				{
				    wxFgets( buf , 1999 , fp );
				    content += buf;
				}    
				fclose(fp);

        		editterm->abs_CleanAll();
        		editterm->parse( (char*) content.c_str() );
        		editterm->gotoXY(0,0);
        		editterm->ScrollToCaret();
//				editterm->repaint();

        		filename = path;
        		editterm->setUnchanged();
        		UpdateTitle();
	        }    
	        break;
	    case MENU_SAVEFILE :
			SaveFile();
	        break;
	    case MENU_SAVENEWFILE :
	        SaveNewFile();
	        break;
		case MENU_QUIT :
  			Close();
  			break;
	}	
}    

void frame_EditTerm::OnEdit(wxCommandEvent& event)
{
	int id = event.GetId();
	switch(id)
	{
		case MNU_DELETELINE :
		    editterm->DeleteLine();
			break;
		case MNU_DELETELINETAIL :
			editterm->DeleteLineTail();
		    break;
		case MNU_JOINLINE :
      		editterm->JoinLine();
      		break;
	    case MNU_COPY :
			editterm->CopySelectionToClipboard(false);
			editterm->CancelSelection();
     		break;
	    case MNU_COPY_ANSI :
			editterm->CopySelectionToClipboard(true);
			editterm->CancelSelection();
     		break;
	    case MNU_PASTE : editterm->PasteFromClipboard(false);	break;
	    case MNU_PASTE_ANSI : editterm->PasteFromClipboard(true);	break;
	    case MNU_SELECTALL : editterm->SelectAll(); break;
	    case MNU_INPUT_LINE :
#ifdef __WXGTK__
			wxString line = GetMultilineTextFromUser( _T("пJneXT"), _T("J"), this );
#else
			wxString line = wxGetTextFromUser( _T("пJneXT"), _T("J"), _T("") );
#endif
			if( ! line.IsEmpty() )
				editterm->Paste( wxStringToCharPtr(line) , false );         	
			break;
	}    
}
    
void frame_EditTerm::OnCharProperty(wxCommandEvent& event)
{
	int id = event.GetId();
	if( id >= MENU_CHARPROP_CHCOLOR_1 && id <= MENU_CHARPROP_CHCOLOR_8 )
		editterm->setSelectionColor( id - MENU_CHARPROP_CHCOLOR_1 + 30 );
	else if( id >= MENU_CHARPROP_BGCOLOR_1 && id <= MENU_CHARPROP_BGCOLOR_8 )
		editterm->setSelectionBgColor( id - MENU_CHARPROP_BGCOLOR_1 + 40 );
	else switch(id)
	{
		case MENU_CHARPROP_NORMAL :		editterm->setSelectionNormal();	break;
	    case MENU_CHARPROP_BLINK :		editterm->setSelectionBlink(true); break;
	    case MENU_CHARPROP_UNBLINK :	editterm->setSelectionBlink(false); break;
	    case MENU_CHARPROP_HIGHLIGHT :	editterm->setSelectionHighlight(true); break;
	    case MENU_CHARPROP_UNHIGHLIGHT :editterm->setSelectionHighlight(false); break;
	    case MENU_CHARPROP_UNDERLINE :	editterm->setSelectionUnderline(true); break;
	    case MENU_CHARPROP_UNUNDERLINE :editterm->setSelectionUnderline(false); break;
	}
}    

frame_EditTerm::frame_EditTerm(const wxString& title, const wxPoint& pos, const wxSize& size, long style)
	   : wxFrame(NULL, -1, title, pos, size, style)
{

	filename = wxEmptyString;

	wxMenuBar *menuBar = new wxMenuBar();

	wxMenu *menuFile = new wxMenu;
	menuFile->Append(MENU_OPENNEWWINDOW , _T("}s (&W)") );
	menuFile->AppendSeparator();
	menuFile->Append(MENU_OPENNEWFILE , _T("}ҷs (&N)") );
	menuFile->Append(MENU_OPENOLDFILE , _T("} (&O)") );
	menuFile->Append(MENU_SAVEFILE , _T("xsɮ (&S)\tCtrl-S") );
	menuFile->Append(MENU_SAVENEWFILE , _T("tsɮ (&E)") );
	menuFile->AppendSeparator();
	menuFile->Append(MENU_QUIT , _T("} (&Q)\tAlt-F4") );
	menuBar->Append(menuFile, _T("ɮ(&F)"));

	wxMenu *editMenu = new wxMenu;
	editMenu->Append(MNU_DELETELINE , _T("Rr (&Y)\tCtrl-Y") );
	editMenu->Append(MNU_DELETELINETAIL , _T("R (&K)\tCtrl-K") );
	editMenu->Append(MNU_JOINLINE , _T("X֤U@ (&K)\tCtrl-J") );
	editMenu->AppendSeparator();
	editMenu->Append(MNU_COPY , _T("ƻs (u¤r) (&C)\tAlt-C") );
	editMenu->Append(MNU_PASTE, _T("KW (u¤r) (&V)\tAlt-V") );
	editMenu->AppendSeparator();
	editMenu->Append(MNU_COPY_ANSI , _T("ƻs (]tANSIm) (&B)\tCtrl-Alt-C") );
	editMenu->Append(MNU_PASTE_ANSI, _T("KW (]tANSIm) (&P)\tCtrl-Alt-V") );
	editMenu->AppendSeparator();
	editMenu->Append(MNU_SELECTALL , _T("ӵe (&A)\tAlt-A") );
	editMenu->AppendSeparator();
	editMenu->Append(MNU_INPUT_LINE, _T("J... (&L)\tAlt-L") );
	menuBar->Append(editMenu, _T("s(&E)"));

	menuCharProp = new wxMenu;
	menuCharProp->Append(MENU_CHARPROP_NORMAL , _T("`ݩ (Ҧݩ)\tCtrl-N") );
	menuCharProp->AppendSeparator();

	wxMenuItem *mi;
	wxChar *name[] = { _T(""), _T(""), _T(""), _T(""), _T(""), _T(""), _T("Q"), _T("") };

	wxMenu *menuTextColor = new wxMenu;
	for(int i=0;i<8;i++)
	{	mi = new wxMenuItem(NULL, MENU_CHARPROP_CHCOLOR_1 + i , wxString::Format(_T("%sr \tCtrl-%d"), name[i], (i+1)) );	/*mi->SetTextColour(TerminalColors[0][i]);*/	menuTextColor->Append(mi);	}
	menuCharProp->Append(0, _T("rC"), menuTextColor);

	wxMenu *menuBackColor = new wxMenu;
	for(int i=0;i<8;i++)
	{	mi = new wxMenuItem(NULL, MENU_CHARPROP_BGCOLOR_1 + i , wxString::Format(_T("%sI \tCtrl-Shift-%d"), name[i], (i+1)) );	/*mi->SetBackgroundColour(TerminalColors[0][i]);*/	menuBackColor->Append(mi);	}
	menuCharProp->Append(0, _T("IC"), menuBackColor);

	menuCharProp->AppendSeparator();

	menuCharProp->Append(MENU_CHARPROP_BLINK , _T("{{\tCtrl-B") );
	menuCharProp->Append(MENU_CHARPROP_UNBLINK , _T("{{\tCtrl-V") );
	menuCharProp->AppendSeparator();
	menuCharProp->Append(MENU_CHARPROP_HIGHLIGHT , _T("G \tCtrl-H") );
	menuCharProp->Append(MENU_CHARPROP_UNHIGHLIGHT , _T("qG \tCtrl-G") );
	menuCharProp->AppendSeparator();
	menuCharProp->Append(MENU_CHARPROP_UNDERLINE , _T("u \tCtrl-U") );
	menuCharProp->Append(MENU_CHARPROP_UNUNDERLINE , _T("Lu \tCtrl-I") );

	menuBar->Append(menuCharProp, _T("rݩ(&T)"));


	wxMenu *helpMenu = new wxMenu;
	helpMenu->Append(MENU_About, _T(" BBMan mrs{ (&A)\tF1") );
	menuBar->Append(helpMenu, _T("(&R)"));


	SetMenuBar(menuBar);

#if ! defined(__WXGTK__)
	CreateStatusBar();
	SetStatusText( GetStatusBarText() );
	SetStatusBarPane(-1);
#endif




	//]w terminal r
	SetFont( GetCurrentFont() );


	editterm = NULL;
	editterm_win = new EditTerm_win(this);
	editterm_win->SetPopupMenu(menuCharProp);
	editterm = editterm_win->editterm;
	editterm->SetFont(GetCurrentFont());
	editterm->setEnableDoubleByteDetection(false);
	editterm->abs_CleanAll();
	editterm->gotoXY(0,0);

	wxSize cs = editterm->getCharSize();
	SetClientSize( cs.GetWidth() * 82 , cs.GetHeight() * 24 );

	UpdateTitle();
}

void frame_EditTerm::SetTerminalFont(wxFont fnt)
{
	editterm->SetFont(fnt);
	editterm_win->SetFont(fnt);
	editterm_win->Refresh(false);
	wxSize cs = editterm->getCharSize();
	SetClientSize( cs.GetWidth() * 82 , cs.GetHeight() * 24 );
}

void frame_EditTerm::OnClose(wxCloseEvent& event)
{
	if( event.CanVeto() )	//pGOtαj
		if( editterm->isChanged() )
			if( wxNO == wxMessageBox( _T("ثeɮפwB|xsATwn{H") , _T("T{"), wxYES_NO ) )
			{
				event.Veto();	//t 
				return;
			}

	CloseAnsiEditor(this);
	this->Destroy();	//			
}    

void frame_EditTerm::OnAbout(wxCommandEvent& WXUNUSED(event))
{	ShowAbout();	}

// ============================================================================
#endif
