/******************************************************************************
 * {]p̡GFjt@²EF@2004/02
 *
 * nĥ GPL vAҦ{XҥiۥѴGέק
 * Ҧ{]p̤TФHOd :)
 ******************************************************************************/


#ifndef SITES_FRAME_CPP
#define SITES_FRAME_CPP

#include <wx/treectrl.h>
#include <wx/dialog.h>

#include "main.cpp" //struct SiteInfo
// ----------------------------------------------------------------------------

class Site_Edit_Frame : public wxDialog
{
public:
	Site_Edit_Frame(wxString _title, SiteInfo *siteinfo);

	bool check();

	SiteInfo *si;
	wxTextCtrl txtName, txtIP, txtPort, txtUsername, txtPassword, txtMessage;
	wxStaticText  stxtName, stxtIP, stxtPort, stxtUsername, stxtPassword , stxtMessage;
	wxButton btnOK, btnCancel;
	wxCheckBox chkAutoOpen , chkAutoLogin;
};

Site_Edit_Frame::Site_Edit_Frame(wxString _title, SiteInfo *siteinfo)
	: wxDialog( NULL, -1, _title, wxDefaultPosition )
{
	si = siteinfo;

	wxBoxSizer *sub_sizer, *sizer = new wxBoxSizer( wxVERTICAL );
	
	sub_sizer = new wxBoxSizer( wxHORIZONTAL );
	stxtName.Create(this, -1, _T("suW") );
	txtName.Create(this, -1, si->name );
	sub_sizer->Add( &stxtName , 1 , wxEXPAND | wxALL , 6  );	sub_sizer->Add( &txtName , 1 , wxEXPAND | wxALL , 6 );
	sizer->Add( sub_sizer );

	sub_sizer = new wxBoxSizer( wxHORIZONTAL );
	stxtIP.Create(this, -1, _T("D}") );
	txtIP.Create(this, -1, si->ip );
	sub_sizer->Add( &stxtIP , 0 , wxEXPAND | wxALL , 6 );	sub_sizer->Add( &txtIP , 1 , wxEXPAND | wxALL , 6 );
	sizer->Add( sub_sizer , 1 );

	sub_sizer = new wxBoxSizer( wxHORIZONTAL );
	stxtPort.Create(this, -1, _T("Port") );
	txtPort.Create(this, -1, wxString::Format( _T("%d") , si->port) );
	sub_sizer->Add( & stxtPort , 0 , wxEXPAND | wxALL , 6  );	sub_sizer->Add( &txtPort , 1 , wxEXPAND | wxALL , 6 );
	sizer->Add( sub_sizer , 1 );

	sub_sizer = new wxBoxSizer( wxHORIZONTAL );
	chkAutoOpen.Create(this, -1, _T("{Ұʮɦ۰ʳsu") );
	chkAutoOpen.SetValue( si->isAutoOpen() );
	sub_sizer->Add( &chkAutoOpen , 0 , wxEXPAND | wxALL , 6 );
	sizer->Add( sub_sizer , 1 );

	sub_sizer = new wxBoxSizer( wxHORIZONTAL );
	chkAutoLogin.Create(this, -1, _T("۰ʵnJ") );
	chkAutoLogin.SetValue( si->isAutoLogin() );
	sub_sizer->Add( &chkAutoLogin , 0 , wxEXPAND | wxALL , 6  );
	sizer->Add( sub_sizer , 0 );

	sub_sizer = new wxBoxSizer( wxHORIZONTAL );
	stxtUsername.Create(this, -1, _T("nJb") );
	txtUsername.Create(this, -1, si->username );
	sub_sizer->Add( &stxtUsername , 0 , wxEXPAND | wxALL , 6  );	sub_sizer->Add( &txtUsername , 0 , wxEXPAND | wxALL , 6 );
	sizer->Add( sub_sizer , 1 );

	sub_sizer = new wxBoxSizer( wxHORIZONTAL );
	stxtPassword.Create(this, -1, _T("nJKX") );
	txtPassword.Create(this, -1, si->GetPassword(), wxDefaultPosition, wxDefaultSize, wxTE_PASSWORD );
	sub_sizer->Add( &stxtPassword , 0 , wxEXPAND | wxALL , 6  );	sub_sizer->Add( &txtPassword , 0 , wxEXPAND | wxALL , 6 );
	sizer->Add( sub_sizer , 1 );

	sub_sizer = new wxBoxSizer( wxHORIZONTAL );
	stxtMessage.Create(this, -1, _T("bsu (Φ۰ʵnJ) ۰ʿX BBMan 榡ưT\r\n (  BBMan 榡ưTаѦ []  )G") );
	sub_sizer->Add( &stxtMessage , 0 , wxEXPAND | wxALL , 6  );
	sizer->Add( sub_sizer , 1 );

	sub_sizer = new wxBoxSizer( wxHORIZONTAL );
	txtMessage.Create(this, -1, si->message, wxDefaultPosition, wxDefaultSize, wxTE_PASSWORD );
	sub_sizer->Add( &txtMessage , 0 , wxEXPAND | wxALL , 6 );
	sizer->Add( sub_sizer , 1 );

	sub_sizer = new wxBoxSizer( wxHORIZONTAL );
	btnOK.Create(this, wxID_OK , _T("Tw") );
	btnCancel.Create(this, wxID_CANCEL, _T("") );
	sub_sizer->Add( & btnOK , 0 , wxEXPAND | wxALL , 6 );	sub_sizer->Add( & btnCancel , 0 , wxEXPAND | wxALL , 6 );
	sizer->Add( sub_sizer , 1 );

	
	SetSizer(sizer);
	sizer->SetSizeHints( this );
	SetAutoLayout( TRUE );
}

bool Site_Edit_Frame::check()
{
	if( isAnonymousLogin() )
	{
		if( chkAutoLogin.GetValue() || ! txtMessage.GetValue().IsEmpty() )
		{
			if( wxNO == wxMessageBox( _T("zĿFe۰ʵnJfﶵAάObesu۰ʿX榡ưTfJơAOzثeOΦWnJ BBMan\noNzҿJbKXi|QߤHh}\n\nTwn~H") , _T("T{") , wxYES_NO ) )
				return false;
		}
	}

	if( txtIP.GetValue() == wxEmptyString )	wxMessageBox(_T("пJD}"));
	else if( txtPort.GetValue() == wxEmptyString )	wxMessageBox(_T("пJ Port"));
	else if( txtName.GetValue() == wxEmptyString )	wxMessageBox(_T("пJsuW"));
	else if( chkAutoLogin.GetValue() && (txtUsername.GetValue().IsEmpty() || txtPassword.GetValue().IsEmpty()) )
		wxMessageBox(_T("zFe۰ʵnJfﶵAJnJbMKX"));
	else
	{
		si->name = txtName.GetValue();
		si->ip = txtIP.GetValue();
		txtPort.GetValue().ToLong( (long*) &(si->port) );
		si->autoopen = chkAutoOpen.GetValue();
		if( chkAutoLogin.GetValue() )
		{
			si->username = txtUsername.GetValue();
			si->SetPassword( txtPassword.GetValue() );
		}
		else
		{
			si->username = _T("");
			si->SetPassword( _T("") );
		}
		si->message = txtMessage.GetValue();

		return true;
//		EndModal(wxID_OK);
	}		
	return false;
}

bool ShowSiteEditDialog(wxString _title, SiteInfo *si)
{
	Site_Edit_Frame f(_title, si);
	while(true)
	{
		int ret = f.ShowModal();
		if(ret == wxID_CANCEL)	return false;
		if( f.check() )	return true;
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

enum { ITEM_FOLDER , ITEM_SITE };

class Sites_Frame : public wxDialog
{
public:
	Sites_Frame();
	
	wxString getName()	{	return name;	}
	wxString getIP()	{	return ip;	}
	int getPort()	{	return port;	}

private:
	wxTreeCtrl tree;
	wxTreeItemId  list_root;
	wxButton btnOK, btnCancel;

	wxString name, ip;
	int port;
	
	void OnMouseDoubleClick(wxMouseEvent& event);

	bool LoadSiteList(wxTreeItemId  rootId);
	void OnOpenSite(wxCommandEvent& event);

public:
	bool getSiteInfo(wxString &_ip, int &_port, wxString &_name);

private:
    DECLARE_EVENT_TABLE()
};

enum { MENU_OPENSITE };

BEGIN_EVENT_TABLE(Sites_Frame, wxDialog)
	EVT_MENU(MENU_OPENSITE, Sites_Frame::OnOpenSite)
	EVT_LEFT_DCLICK( Sites_Frame::OnMouseDoubleClick )
END_EVENT_TABLE()

// ----------------------------------------------------------------------------

bool Sites_Frame::getSiteInfo(wxString &_ip, int &_port, wxString &_name)
{
	wxTreeItemId nodeId = tree.GetSelection();
	if( nodeId > 0
 		&& tree.GetItemImage( nodeId ) == ITEM_SITE )	//ӥB item O@ site
	{
		wxString txt = tree.GetItemText(nodeId);

		txt.AfterLast(' ').ToLong( (long*)&_port);
		_name = txt.BeforeLast(' ');
		_ip = _name.AfterLast(' ');
		_name = _name.BeforeLast(' ');

		return true;
	}
	else return false;
}

// ----------------------------------------------------------------------------

Sites_Frame::Sites_Frame()
	: wxDialog( NULL, -1, wxString(_T("BBS C")), wxDefaultPosition, wxSize(500, 500) )
{

	wxMenuBar *menuBar = new wxMenuBar();

	wxMenu *menuFile = new wxMenu;
	menuFile->Append(MENU_OPENSITE, _T("}ҳoӳsu") );
	menuBar->Append(menuFile, _T("su(&C)"));


	tree.Create(this, 666, wxDefaultPosition, this->GetClientSize(), wxTR_DEFAULT_STYLE | wxTR_HIDE_ROOT );
	tree.SetNextHandler(this);


	wxBoxSizer *sub_sizer, *sizer = new wxBoxSizer( wxVERTICAL );

	sub_sizer = new wxBoxSizer( wxHORIZONTAL );
	btnOK.Create(this, wxID_OK , _T("Tw") );
	btnCancel.Create(this, wxID_CANCEL, _T("") );
	sub_sizer->Add( & btnOK , 0 , wxEXPAND | wxALL , 6 );	sub_sizer->Add( & btnCancel , 0 , wxEXPAND | wxALL , 6 );
	sizer->Add( sub_sizer );

	sizer->Add( &tree );

	SetSizer(sizer);
	sizer->SetSizeHints( this );
	SetAutoLayout( TRUE );




	wxTreeItemId  root;
	
	root = tree.AddRoot(_T(""));

	list_root = tree.AppendItem(root, _T("Uj BBS"));
	LoadSiteList(list_root);
}
// ----------------------------------------------------------------------------
void Sites_Frame::OnOpenSite(wxCommandEvent& event)
{
	wxMouseEvent e;
	OnMouseDoubleClick(e);
}
// ----------------------------------------------------------------------------
void Sites_Frame::OnMouseDoubleClick(wxMouseEvent& event)
{
	wxTreeItemId nodeId = tree.GetSelection();
	if( nodeId > 0
 		&& tree.GetItemImage( nodeId ) == ITEM_SITE )	//ӥB item O@ site
	{
		EndModal(wxID_OK);
	}
}
// ----------------------------------------------------------------------------
bool Sites_Frame::LoadSiteList(wxTreeItemId  rootId)
{
	FILE *fp = wxFopen( _T("sites.dat") , _T("r") );
	if(fp==NULL)	return false;

	wxTreeItemId  now_root_Id , parent_node_Id[1000];
	int deep = 0;
	now_root_Id = rootId;
	
	wxChar buf[1024];
	while( wxFgets( buf, 1024, fp ) != NULL )
	{
		switch( buf[0] )
		{
			case 's':	//define a site
				tree.AppendItem( now_root_Id , buf+1 , ITEM_SITE );
				break;
			case 'd':	//mkdir
				parent_node_Id[ deep++ ] = now_root_Id;
				now_root_Id = tree.AppendItem( now_root_Id , buf+1, ITEM_FOLDER );
				break;
			case '\n':
			case '\r':
			case '\0':	//cdup
				if( deep > 0 )
					now_root_Id = parent_node_Id[ --deep ];
				break;
			default:
				break;
		}
	}
	
	tree.Expand( rootId );
	
	fclose(fp);
	return true;
}
// ----------------------------------------------------------------------------
bool ShowSiteListDialog(wxString &_ip, int &_port, wxString &_name)
{
	Sites_Frame f;
	if( wxID_OK == f.ShowModal() )
	{
		if( ! f.getSiteInfo( _ip , _port , _name ) )	return false;
		return true;
	}
	else	return false;
}
// ----------------------------------------------------------------------------
#endif
